# Uniform - Universal Forms for Elm

The World Wide Web is full of forms: simple and static, complex and dynamic.
Most likely that you have filled a couple before getting in there: a search field is also a form (just a really tiny one)!

Implementing forms is considered one of the most boring and repetitive tasks in web development.
This library helps to stay sane when implementing forms in the greatest frontend language: Elm.

If this library made you insane, then this is a bug in the library!

## Design goals

* Forms are wild beasts, requirements change constantly.
  Users should **spend less time** dealing with forms because of this library, not more.
* In-place editable forms are first-class citizens. Classic forms must be easy once you have in-place ones.
* Embrace the type system, everything should be **type-safe** but **extensible**.
* No two forms look the same - the library should make it extremely easy to define a **fully custom view**.
* All customization options should not [force users to re-implement half of the library][1] with their custom types.

[1] : https://github.com/hecrj/composable-form/issues/32

## Examples

TODO: link to the examples folder and ellies
